package com.flow.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.handlers.JacksonTypeHandler;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import com.flow.enums.NotifyEnum;
import lombok.Data;

import java.time.LocalDateTime;
import java.util.Map;

@Data
@TableName(value = "sys_notify", autoResultMap = true)
public class Notify {
    @JsonSerialize(using = ToStringSerializer.class)
    @TableId(type = IdType.AUTO)
    private Long id;
    @TableField(condition = SqlCondition.LIKE)
    private String subject;
    @TableField(condition = SqlCondition.LIKE)
    private String content;
    private String sender;
    private String receiver;
    private NotifyEnum type;
    private LocalDateTime receivingTime;
    private Boolean isRead;
    private Boolean archived;
    private String url;
    @TableField(typeHandler = JacksonTypeHandler.class)
    private Map<String, Object> params;
}
