package com.flow.entity;
import com.baomidou.mybatisplus.annotation.SqlCondition;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.flow.common.mybatis.entity.BaseEntity;
import com.zaxxer.hikari.HikariDataSource;
import lombok.Data;
import lombok.EqualsAndHashCode;

import javax.sql.DataSource;

@Data
@EqualsAndHashCode(callSuper = true)
@TableName("report_datasource")
public class ReportDatasource extends BaseEntity {
    @TableField(condition = SqlCondition.LIKE)
    private String name;
    private String url;
    private String driverClass;
    private String username;
    private String password;

    public DataSource buildDataSource() {
        HikariDataSource datasource = new HikariDataSource();
        datasource.setJdbcUrl(url);
        datasource.setDriverClassName(driverClass);
        datasource.setUsername(username);
        datasource.setPassword(password);
        return datasource;
    }
}
