package com.flow.cmd;

import lombok.AllArgsConstructor;
import org.flowable.common.engine.impl.interceptor.Command;
import org.flowable.common.engine.impl.interceptor.CommandContext;
import org.flowable.engine.impl.util.CommandContextUtil;
import org.flowable.identitylink.service.HistoricIdentityLinkService;
import org.flowable.identitylink.service.impl.persistence.entity.HistoricIdentityLinkEntity;

import java.util.Date;
import java.util.List;

@AllArgsConstructor
public class CcCmd implements Command<Void> {
    private String processInstanceId;
    private List<String> ccUsers;


    @Override
    public Void execute(CommandContext commandContext) {
        HistoricIdentityLinkService historicIdentityLinkService = CommandContextUtil.getProcessEngineConfiguration(commandContext)
                .getIdentityLinkServiceConfiguration()
                .getHistoricIdentityLinkService();
        for (String ccUser : ccUsers) {
            HistoricIdentityLinkEntity historicIdentityLink = historicIdentityLinkService.createHistoricIdentityLink();
            historicIdentityLink.setType("cc");
            historicIdentityLink.setUserId(ccUser);
            historicIdentityLink.isUser();
            historicIdentityLink.setCreateTime(new Date());
            historicIdentityLink.setProcessInstanceId(processInstanceId);
            historicIdentityLinkService.insertHistoricIdentityLink(historicIdentityLink, false);
        }
        return null;
    }
}
