package com.flow.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.flow.common.core.model.PageResult;
import com.flow.common.mybatis.service.impl.BaseServiceImpl;
import com.flow.dao.FlowCcDao;
import com.flow.entity.FlowCc;
import com.flow.model.FlowCcQuery;
import com.flow.service.FlowCcService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class FlowCcServiceImpl extends BaseServiceImpl<FlowCcDao, FlowCc> implements FlowCcService {
    @Autowired
    private FlowCcDao flowCcDao;

    @Override
    public PageResult<FlowCc> list(FlowCcQuery flowCcQuery) {
        Page<FlowCc> page = new Page<>(
                flowCcQuery.getPage(),
                flowCcQuery.getLimit()
        );
        IPage<FlowCc> iPage = flowCcDao.list(page, flowCcQuery);
        return new PageResult<>(iPage.getTotal(), iPage.getRecords());
    }
}
