package com.flow.entity.form;

import com.fasterxml.jackson.annotation.JsonSubTypes;
import com.fasterxml.jackson.annotation.JsonTypeInfo;
import com.flow.entity.node.FormProperty;
import lombok.Data;

import java.util.Map;

@JsonTypeInfo(
        use = JsonTypeInfo.Id.NAME,
        property = "type",
        defaultImpl = Field.class,
        visible = true
)
@JsonSubTypes({
        @JsonSubTypes.Type(value = FormItem.class, name = "formItem"),
        @JsonSubTypes.Type(value = Container.class, name = "container")
})
@Data
public abstract class Field {
    private String id;
    private String type;
    private String name;
    private Boolean hidden;
    private Integer span;
    private Map<String, Object> props;

    public abstract void populateValue(Map<String, Object> variables);

    public abstract void populateProperty(FormProperty formProperty);
}
